function [gk,Gk] = kalman_g(k,xk)

% Note that due to format supported by kalman smoother, u is global
% variable that will be accessed using k


global dt
global map 
global threshold
global input_u
global filter_index
global initial_x


%
% Returns the new state x(t+1) = f(x(t),u(t)) 

n = size(xk, 1);
Gk    = zeros(n, n);
gk    = zeros(n, 1);

%and the reading z(t) =
% h(x(t)).
%

% get the input from the global variable

u = input_u((k+filter_index), :);
%u = input_u(k, :);

if ( nargin == 2 )
    dt = 1;
end


% First predict the state

theta = xk(3);
%theta = mod(xk(3), 2*pi);


% specifying initial state estimate
if (k == 1)
    Gk = zeros(3,3);
    gk = initial_x;
    return
end


if ( ( u(1) == 0 ) && ( u(2) == 0 ) )
    
    gk = xk;

elseif ( u(2) ~= 0 )
    
    theta = xk(3);
    gk(1) = xk(1) - (u(1)/u(2))*sin(theta)+(u(1)/u(2))*sin(theta+u(2)*dt);
    gk(2) = xk(2) + (u(1)/u(2))*cos(theta)-(u(1)/u(2))*cos(theta+u(2)*dt);
    gk(3) = xk(3) + u(2)*dt;
    
else
    
    gk(1) = xk(1) + u(1)*cos(theta)*dt;
    gk(2) = xk(2) + u(1)*sin(theta)*dt;
    gk(3) = xk(3);
    
end


% Now compute the Jacobian G

Gk = zeros(3,3);

if ( u(2) ~= 0 )
    
    Gk(1,1) = 1;
    Gk(1,3) = -(u(1)/u(2))*cos(theta)+(u(1)/u(2))*cos(theta+u(2)*dt);
    Gk(2,2) = 1;
    Gk(2,3) = -(u(1)/u(2))*sin(theta)+(u(1)/u(2))*sin(theta+u(2)*dt);
    Gk(3,3) = 1;
        
else
    
    Gk(1,1) = 1;
    Gk(1,3) = -u(1)*sin(theta)*dt;
    Gk(2,2) = 1;
    Gk(2,3) = u(1)*cos(theta)*dt;
    Gk(3,3) = 1;
        
end
