
function [x_filt] = run_smoother_new(nums)

tic

close all
%clear all

% Controls for program run
filter = 1;  % 1 to run filter, 0 to not run
%directory = 'dataSet2';
init_truth = 0; % 0 for normal run, 1 to start at truth
method           = 'ckbs_nonlinear'; % do not change for now
window = 2;       % size of window
use_covariances = 1;   % 1 to use covariances in filter, 0 to use super naive approach
use_constraints = 0;   % 1 to use constraints, 0 not to

use_warmstart = 1;

level = 0;
max_itr = 40;
%----------------------------------------------

global input_u
global map
global threshold
global dt
global filter_index % variable needed for filter impementation to keep track of input
global initial_x % set the first point of the smoother
global A
global b
global angleIndex

% Ignore if 0
angleIndex = 0;


NMonte = 99;

errorsSmoother = zeros(3,1);
err = zeros(3,NMonte);

for window = 2:2
    
    for monte = 1:NMonte
        
        method           = 'ckbs_nonlinear'; % do not change for now
        
        directory = sprintf('../code/Smoothing/data/SmootherDataNoisyAll%d',monte);
%        directory = 'SmootherData1';
        
        data = [directory, '/data'];
        
        %
        data(:,3) = abs(data(:,3));
        
        threshold = [directory, '/threshold'];
        
        map = [directory, '/map'];
        groundTruth = [directory, '/groundTruth'];
        dt = [directory, '/dt'];
        cv = [directory,'/cvfix'];
        variances = [directory,'/alpha'];
        %startpose = [directory, '/startpose'];
        load(cv);
        al = load(variances);
        % load(startpose);
        al = load(variances);
        load '../code/Smoothing/data/startposes'
        startpose = startposes(:,monte);
        startpose = startpose';
        
        
        load(data);
        load(map);
        load(threshold);
        
        %SASHA DEBUG
        load(dt);
        truth = load(groundTruth);
        gt = truth.x;
        gt = gt';
        
        % Constraints
        
        if(use_constraints == 1)
            A = load([directory, '/A']);
            b = load([directory, '/b']);
        end
        
        eps = 1e-3;
        
        varProcess = al.alpha(1);
        varMeas = cvfix;
        
        
        % Set initila state to initial ground trth state
        xOne = startpose;
        
        nx = 3;   % size of state
        
        z = data(:, 3:end)';
        % z = [ zeros(12,1) z ];
        % z = z(:,1:end-1);
        
        nz = size(z, 1);      % length of each observation
        
        % SASHA Filter implementation
        
        num_data = size(z, 2);% number of observations
        
        if (nargin == 1)
            num_data = nums;
        end
        
        z = z(:, 1:num_data);
        gt = gt(:, 1:num_data);
        
        %-----------------------------
        
        rinv = zeros(nz, nz, num_data);
        qinv = zeros(3, 3, num_data);
        
        for i = 1:num_data
            
            for j = 1:nz
                if z(j,i) > eps
                    % set diagonal of measurement information to 1 if there was an observation
                    rinv(j, j, i) = 1/varMeas;
                end
                
            end
            
            for k = 1:nx
                % Set diagonal of process information to 1
                qinv(k, k, i) = 1/varProcess;
                
            end
        end
        
%         %qinv(1, 1, 1) = 1/10000;
%         %qinv(2, 2, 1) = 1/10000;
%         %qinv(3, 3, 1) = 1/10000;
%         %DEBUG
%         qinv(1, 1, 1) = 100000;
%         qinv(2, 2, 1) = 100000;
%         qinv(3, 3, 1) = 100000;
        
        
        
          % Lack of initial knowledge
%         qinv(1, 1, 1) = 1/10000;
%         qinv(2, 2, 1) = 1/10000;
%         qinv(3, 3, 1) = 1/10000;
        
        % Full initial knowledge
        qinv(1, 1, 1) = 10000;
        qinv(2, 2, 1) = 10000;
        qinv(3, 3, 1) = 10000;
        
        
        
        qinv_old = qinv;
        
        
        % build the input
        input_u = data(1:num_data, 1:2);
        
        
        epsilon = 1e-3;        % Kalman smoother convergnece criteria
        ell     = 1;           % Number of constraints (constraint is not active)
        n       = 3;           % Number of components in the state vector
        
        x_in    = zeros(n, num_data); % Initialize x vector at all time points
        %x_in(:,1) = xOne';
        %
        if(use_constraints == 1)
            f_fun = 'kalman_f';  % constraints are currently turned off by the kalman_f file
        else
            f_fun = 'kalman_f_noc';
        end
        g_fun = 'kalman_g';
        h_fun = 'kalman_h';
        z_fit     = z;
        
        
        
        
        if(init_truth == 1)
            x_in = truth';
            
        end
        
        
        if(filter == 1)
            
            %initial_x = [5;5;0];
            initial_x = startpose';
            x_filt = zeros(n, num_data);
            Xh = x_filt;
            Xh_new = Xh;
            
            
            %Sasha: debug
            %window = num_data;
            
            storeInfo = zeros(3, 3, num_data);
            var = zeros(3, 3, window);  % for filter
            varZero = var;
            
            
            for i = 1:num_data
                if (i <= window)
                    var = varZero;
                    
                    filter_index = 0; % necessary for kalman_g function
                    input = Xh(:, 1:i);
                    
                    if(use_warmstart == 1)
                        if i == 1
                            input(:, i) = initial_x;
                        end
                        if i == 2
                            input(:,i) = kalman_g(2, initial_x);
                        end
                        
                        if (i > 2)
                            input(:,i) = kalman_g(i-1, input(:,(i-1)));
                        end
                    end
                    
                    [Xh_new(:,1:i), u_out, info, var(:,:,1:i)] = feval(method,         ...
                        f_fun,              ...
                        g_fun,              ...
                        h_fun,              ...
                        max_itr,            ...
                        epsilon,            ...
                        input,         ...
                        z_fit(:,  1:i),     ...
                        qinv(:,:, 1:i),     ...
                        rinv(:,:, 1:i),     ...
                        level               ...
                        );
                    Xh = Xh_new;
                    x_filt(:, i) = Xh(:,i);
                    initial_x = Xh(:,1);
                    
                    
                    if(use_covariances == 1)
                        %if (i==1)
                        %    qinv(:,:,1) = chol_solve(var(:,:,1), eye(3)); %initialize first block
                        %end
                        if (i >= 2)
                            % initialize second block for use by general code
                            storeInfo(:,:,i) = chol_solve(var(:,:,i), eye(3));
                        end
                    end
                end
                
                if (i > window)
                    
                    filter_index = i - window; % necessary for kalman_g function
                    var = varZero;
                    
                    if (use_covariances == 1) % update the first used qinv only.
                        qinv(:,:, filter_index + 1) = storeInfo(:,:,filter_index + 1);
                    end
                    
                    
                    input =  Xh(:, (filter_index + 1):i);
                    
                    % need to change filter index for next line
                    if(use_warmstart == 1)
                        filter_index = i - 3;
                        input(:, window) = kalman_g(2, input(:,window-1)); % results in i-1 input used
                        filter_index = i - window;
                    end
                    
                    [Xh_new(:, (filter_index + 1):i), u_out, info, var] = ...
                        feval(method,         ...
                        f_fun,                          ...
                        g_fun,                          ...
                        h_fun,                          ...
                        max_itr,                        ...
                        epsilon,                        ...
                        input,							...
                        z_fit(:, (filter_index + 1):i),   ...
                        qinv(:,:,(filter_index + 1):i),   ...
                        rinv(:,:,(filter_index + 1):i),   ...
                        level               ...
                        );
                    
                    Xh = Xh_new;
                    x_filt(:, i) = Xh(:,i);
                    initial_x = Xh(:, filter_index + 2); % for next iteration
                    
                    
                    if (use_covariances == 1)
                        storeInfo(:,:,i) = chol_solve(var(:,:,window), eye(3));
                    end
                end
                % always update the ith entry in the storeVar variable.
                
            end
            
            %x_filt(3,:) = mod(x_filt(3,:), 2*pi);
            
        end
        
        filter_index = 0;
        %  initial_x = [5; 5; 0];
        initial_x = startpose';
        var = zeros(3, 3, num_data);
        
        qinv = qinv_old;
        
        %         level = 1;
        %         method = 'ckbs_nonlinear_classic';
        %         % call to the smoother
        %         [x_out,uout,info] = feval(method,         ...
        %             f_fun,         ...
        %             g_fun,         ...
        %             h_fun,         ...
        %             max_itr,       ...
        %             epsilon,       ...
        %             x_in,          ...
        %             z_fit,         ...
        %             qinv,     	...
        %             rinv,     	...
        %             level          ...
        %             );
        %
                x_filt(3,:) = mod(x_filt(3,:), 2*pi);
        
               err(1,monte) = mean((x_filt(1,:)-gt(1,:)).^2);
               err(2,monte) = mean((x_filt(2,:)-gt(2,:)).^2);
               err(3,monte) = mean((GeodesicDistance(x_filt(3,:),gt(3,:))).^2);
        
      %  close all
        %         figure ;
        %         plot(x_out(1,:),x_out(2,:),'b');
        %         hold on
        %         plot(gt(1,:),gt(2,:),'k');
        %         figure
        %         subplot(3,1,1)
        %         plot((x_out(1,:)-gt(1,:)).^2)
        %         subplot(3,1,2)
        %         plot((x_out(2,:)-gt(2,:)).^2)
        %         subplot(3,1,3)
        %         plot((GeodesicDistance(x_out(3,:),gt(3,:))).^2)
        %
        
%         figure ;
%         plot(x_filt(1,:),x_filt(2,:),'b');
%         hold on
%         plot(gt(1,:),gt(2,:),'k');
%         figure
%         subplot(3,1,1)
%         plot((x_filt(1,:)-gt(1,:)).^2)
%         subplot(3,1,2)
%         plot((x_filt(2,:)-gt(2,:)).^2)
%         subplot(3,1,3)
%         plot((GeodesicDistance(x_filt(3,:),gt(3,:))).^2)
        
    end
    
    errorSmoother(:,window-1) = mean(err,2);
    
end


toc

save window2warmKidnappedNoisyAll

% figure
% plot(map(:,1),map(:,2),'r+');
% hold on
% axis equal
% grid on
% plot(truth(1:num_data,1)',truth(1:num_data,2)','k');
% plot(x_out(1,1:num_data),x_out(2,1:num_data),'b');
%
%
%
%
% true_orientation = truth(1:num_data,3)';
%
% truth(1:num_data,3) = mod(truth(1:num_data,3),2*pi);
% %x_out(:,3) = mod(x_out(:,3),2*pi);
%
% true_orientation_degrees = true_orientation * 180 / pi;
% initial_orientation_degrees = x_in(3,1:num_data) * 180 / pi;
%
% filter_orientation_degrees = x_out(3,1:num_data) * 180 / pi;
% final_orientation_degrees = x_out(3,1:num_data) * 180 / pi;
%
% MSExIN = mean(x_in(1,1:num_data)' - truth(1:num_data,1)).^2;
% MSEyIN = mean(x_in(2,1:num_data)' - truth(1:num_data,2)).^2;
% MSEthetaIN = mean(x_in(3,1:num_data)' - truth(1:num_data,3)).^2;
%
% %geodesic_truth();
% geodesic_IN = min(mod((x_in(3,1:num_data)' - truth(1:num_data,3)),2*pi),mod(truth(1:num_data,3) - (x_in(3,1:num_data)'),2*pi));
% geodesic_OUT = min(mod((x_out(3,1:num_data)' - truth(1:num_data,3)),2*pi),mod(truth(1:num_data,3) - (x_out(3,1:num_data)'),2*pi));
%
% if(filter == 1)
%     geodesic_FILTER = min(mod((x_filt(3,1:num_data)' - truth(1:num_data,3)),2*pi),mod(truth(1:num_data,3) - (x_filt(3,1:num_data)'),2*pi));
%     MSEx_filt = mean(x_filt(1,1:num_data)' - truth(1:num_data,1)).^2;
%     MSEy_filt = mean(x_filt(2,1:num_data)' - truth(1:num_data,2)).^2;
%     MSEtheta_filt = mean(x_filt(3,1:num_data)' - truth(1:num_data,3)).^2;
%     MSE_thetaFin_deg_filt = mean(mod(filter_orientation_degrees - true_orientation_degrees,360));
% end
%
%
% MSEx = mean(x_out(1,1:num_data)' - truth(1:num_data,1)).^2;
% MSEy = mean(x_out(2,1:num_data)' - truth(1:num_data,2)).^2;
% MSEtheta = mean(x_out(3,1:num_data)' - truth(1:num_data,3)).^2;
% MSE_thetaFin_deg = mean(mod(final_orientation_degrees - true_orientation_degrees,360));
%
%
%
%
% 'start errors'
%
% [MSExIN MSEyIN MSEthetaIN mean(geodesic_IN)]
%
%
%
% figure
% plot(truth(1:num_data,3),'k');
% grid on
% hold on
% plot(mod(x_out(3,1:num_data),2*pi),'r');
%
%
% if(filter == 1)
%     'filter errors'
%
%     [MSEx_filt MSEy_filt MSEtheta_filt mean(geodesic_FILTER)]
% end
%
% 'ending errors'
% [MSEx MSEy MSEtheta mean(geodesic_OUT)]
%
%
% % now compute the state residuals
%
% xpred = zeros(size(x_out));
% xpred(:,1) = x_out(:,1);
% col = size(x_out,2);
% for j = 2:col
%     xpred(:,j) = System(x_out(:,j-1),input_u(j-1,:));
% end
%
% %xpred(3,:) = mod(xpred(3,:));
%
% residuals = (x_out - xpred) / sqrt(varProcess);
%
% figure ;
% subplot(3,1,1);
% plot(residuals(1,1:num_data));
% legend('x');
% grid on
% subplot(3,1,2);
% plot(residuals(2,1:num_data));
% legend('y');
% grid on
% subplot(3,1,3);
% plot(residuals(3,1:num_data));
% legend('\theta');
% grid on
%
% % now compute the outputs residuals
%
% z_pred = zeros(size(z));
%
% for j = 1:col
%     [z_pred(:,j),p] = kalman_h(j,x_out(:,j));
% end
%
% residuals = z_pred - z;
% figure ; plot(mean(residuals)/sqrt(varMeas))

